create sequence hibernate_sequence start 1 increment 1;
create table appointment
(
    id                 int8 not null,
    appointment_date   timestamp,
    is_registered      boolean,
    appointment_status varchar(255),
    doctor_by          int8,
    patient_id         int8,
    primary key (id)
);
create table core_user_account_detail
(
    detail_id       int8 generated by default as identity,
    detail_address  varchar(255),
    detail_value    varchar(255),
    user_account_id int8,
    primary key (detail_id)
);
create table medical_report
(
    id                   int8 not null,
    attachment_file_name varchar(255),
    creation_date        date,
    diagnosis            varchar(2048),
    prescription         varchar(2048),
    recommendation       varchar(2048),
    survey               varchar(2048),
    doctor_by            int8,
    patient_id           int8,
    primary key (id)
);
create table core_role
(
    role_id          int8 not null,
    category_name    varchar(255),
    is_active        boolean,
    role_code        varchar(255),
    role_description varchar(255),
    role_name        varchar(255),
    primary key (role_id)
);
create table core_user
(
    user_id         int8         not null,
    activation_code varchar(255),
    first_name      varchar(255),
    full_name       varchar(255),
    is_enabled      boolean,
    last_name       varchar(255),
    middle_name     varchar(255),
    user_login      varchar(255) not null,
    user_password   varchar(255) not null,
    primary key (user_id)
);
create table core_user_account
(
    user_account_id    int8 generated by default as identity,
    user_account_email varchar(255),
    user_account_name  varchar(255),
    user_account_phone  varchar(255),
    user_account_profile_icon_name  varchar(255),
    primary key (user_account_id)
);
create table core_user_account_role_link
(
    user_account_role_link_id int8 not null,
    role_id                   int8,
    user_account_id           int8,
    primary key (user_account_role_link_id)
);
create table core_user_account_user_link
(
    user_account_user_link_id int8 not null,
    user_account_id           int8,
    user_id                   int8,
    primary key (user_account_user_link_id)
);
alter table if exists core_role
    add constraint UK_1gg2nrc02x844mvv3emagd028 unique (role_code);
alter table if exists core_user
    add constraint UK_lpa2gpcu09l3o6c11ucvgal1a unique (user_login);
alter table if exists appointment
    add constraint FKqi3lbmq82fnypyb2a35ecso8n foreign key (doctor_by) references core_user_account;
alter table if exists appointment
    add constraint FKjrk02v8ie1cj38ijqa5038cl1 foreign key (patient_id) references core_user_account;
alter table if exists core_user_account_detail
    add constraint FKdrjypjsraimiosrcj59rln3rc foreign key (user_account_id) references core_user_account;
alter table if exists medical_report
    add constraint FK1p8bejyy7ygg9mcx76x6ijr5m foreign key (doctor_by) references core_user_account;
alter table if exists medical_report
    add constraint FK4bq0g273nfil9ldet3wsu976b foreign key (patient_id) references core_user_account;